diff -ruN ../nakedmudv3.7/src/scripts/pyroom.c src/scripts/pyroom.c
--- ../nakedmudv3.7/src/scripts/pyroom.c	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/pyroom.c	2009-03-02 01:00:40.000000000 -0500
@@ -21,6 +21,7 @@
 #include "../handler.h"
 #include "../prototype.h"
 #include "../commands.h"
+#include "../hooks.h"
 
 #include "pyplugs.h"
 #include "scripts.h"
@@ -28,7 +29,7 @@
 #include "pyobj.h"
 #include "pyexit.h"
 #include "pyroom.h"
-#include "pymud.h"
+#include "pymudsys.h"
 #include "pyauxiliary.h"
 
 
@@ -41,6 +42,13 @@
 
 
 //*****************************************************************************
+// mandatory modules
+//*****************************************************************************
+#include "../dyn_vars/dyn_vars.h"
+
+
+
+//*****************************************************************************
 // local structures and defines
 //*****************************************************************************
 
@@ -74,22 +82,48 @@
 int PyRoom_init(PyRoom *self, PyObject *args, PyObject *kwds) {
   char *kwlist[] = {"uid", NULL};
   int        uid = NOTHING;
+  PyObject  *who = NULL;
 
   // get the vnum
-  if (!PyArg_ParseTupleAndKeywords(args, kwds, "i", kwlist, &uid)) {
-    PyErr_Format(PyExc_TypeError, "Rooms may only be created using a uid");
+  if (!PyArg_ParseTupleAndKeywords(args, kwds, "O", kwlist, &who)) {
+    PyErr_Format(PyExc_TypeError, "a room UID or string ID must be supplied");
     return -1;
   }
 
-  // make sure a room with the uid exists
-  if(!propertyTableGet(room_table, uid)) {
-    PyErr_Format(PyExc_TypeError, 
-		 "Room with uid, %d, does not exist", uid);
+  // are we doing it as a uid?
+  if(PyInt_Check(who)) {
+    uid = (int)PyInt_AsLong(who);
+    // make sure a room with the uid exists
+    if(!propertyTableGet(room_table, uid)) {
+      PyErr_Format(PyExc_TypeError, 
+		   "Room with uid, %d, does not exist", uid);
+      return -1;
+    }
+
+    self->uid = uid;
+    return 0;
+  }
+  else if(PyString_Check(who)) {
+    ROOM_DATA *room = NULL;
+    if( (room = worldGetRoom(gameworld, get_fullkey_relative(PyString_AsString(who), get_script_locale()))) != NULL) {
+      self->uid = roomGetUID(room);
+      return 0;
+    }
+    // create a fresh room with the given key, and add it to the game
+    else {
+      room = newRoom();
+      roomSetClass(room, get_fullkey_relative(PyString_AsString(who),
+					      get_script_locale()));
+      worldPutRoom(gameworld, roomGetClass(room), room);
+      room_to_game(room);
+      self->uid = roomGetUID(room);
+      return 0;
+    }
+  }
+  else {
+    PyErr_Format(PyExc_TypeError, "a room UID or string ID must be supplied");
     return -1;
   }
-
-  self->uid = uid;
-  return 0;
 }
 
 int PyRoom_compare(PyRoom *room1, PyRoom *room2) {
@@ -123,14 +157,69 @@
   // try to find the room
   room = worldGetRoom(gameworld, get_fullkey_relative(room_key, get_script_locale()));
 
-  if(room == NULL) {
-    PyErr_Format(PyExc_TypeError, "get room failed: room does not exist or "
-		 "is abstract.");
+  if(room == NULL)
+    return Py_BuildValue("O", Py_None);
+  // create a python object for the new char, and return it
+  return Py_BuildValue("O", roomGetPyFormBorrowed(room));
+}
+
+PyObject *PyRoom_loaded(PyObject *self, PyObject *args) {
+  char     *room_key = NULL;
+  
+  if (!PyArg_ParseTuple(args, "s", &room_key)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "load check failed - it needs a room key/locale.");
     return NULL;
   }
 
-  // create a python object for the new char, and return it
-  return Py_BuildValue("O", roomGetPyFormBorrowed(room));
+  bool val = worldRoomLoaded(gameworld, get_fullkey_relative(room_key, get_script_locale()));
+
+  return Py_BuildValue("i", val);
+}
+
+PyObject *PyRoom_instance(PyObject *self, PyObject *args) {
+  char *room_key = NULL;
+  char   *as_key = NULL;
+ 
+  if (!PyArg_ParseTuple(args, "ss", &room_key, &as_key)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Instance failed. Need source key and instance key.");
+    return NULL;
+  }
+
+  // see if the room is already in existence
+  ROOM_DATA *room = worldGetRoom(gameworld, as_key);
+  if(room != NULL)
+    return Py_BuildValue("O", roomGetPyFormBorrowed(room));
+  else {
+    PROTO_DATA *proto = worldGetType(gameworld, "rproto", room_key);
+    if(proto == NULL) {
+      PyErr_Format(PyExc_TypeError, "prototype %s does not exist.", room_key);
+      return NULL;
+    }
+    as_key = strdupsafe(get_fullkey_relative(as_key, get_key_locale(room_key)));
+    room = protoRoomInstance(proto, as_key);
+    if(room == NULL)
+      return NULL;
+    worldPutRoom(gameworld, as_key, room);
+    free(as_key);
+    return Py_BuildValue("O", roomGetPyFormBorrowed(room));
+  }
+}
+
+PyObject *PyRoom_is_abstract(PyObject *self, PyObject *args) {
+  char     *room_key = NULL;
+  if (!PyArg_ParseTuple(args, "s", &room_key)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "is_abstract failed - it needs a room key/locale.");
+    return NULL;
+  }
+
+  PROTO_DATA *proto = worldGetType(gameworld, "rproto", 
+				   get_fullkey_relative(room_key, get_script_locale()));
+  if(proto == NULL || protoIsAbstract(proto))
+    return Py_BuildValue("i", 1);
+  return Py_BuildValue("i", 0);
 }
 
 
@@ -144,6 +233,24 @@
   else             return NULL;
 }
 
+PyObject *PyRoom_getlocale(PyRoom *self, void *closure) {
+  ROOM_DATA *room = PyRoom_AsRoom((PyObject *)self);
+  if(room != NULL) return Py_BuildValue("s",get_key_locale(roomGetClass(room)));
+  else             return NULL;
+}
+
+PyObject *PyRoom_getprotoname(PyRoom *self, void *closure) {
+  ROOM_DATA *room = PyRoom_AsRoom((PyObject *)self);
+  if(room != NULL) return Py_BuildValue("s",get_key_name(roomGetClass(room)));
+  else             return NULL;
+}
+
+PyObject *PyRoom_getprotos(PyRoom *self, void *closure) {
+  ROOM_DATA *room = PyRoom_AsRoom((PyObject *)self);
+  if(room != NULL) return Py_BuildValue("s", roomGetPrototypes(room));
+  else             return NULL;
+}
+
 PyObject *PyRoom_getuid(PyRoom *self, void *closure) {
   return Py_BuildValue("i", self->uid);
 }
@@ -440,7 +547,7 @@
     return NULL;
   }
 
-  return Py_BuildValue("s", roomGetExitDir(room, exit));
+  return Py_BuildValue("z", roomGetExitDir(room, exit));
 }
 
 
@@ -469,7 +576,7 @@
 
     // is it a special exit? If so, we may need to remove the command as well
     if(dirGetNum(dir) == DIR_NONE) {
-      CMD_DATA *cmd = nearMapRemove(roomGetCmdTable(room), dir);
+      CMD_DATA *cmd = roomRemoveCmd(room, dir);
       if(cmd != NULL)
 	deleteCmd(cmd);
     }
@@ -502,7 +609,7 @@
 
   // make sure we have a valid destination
   if(PyString_Check(py_dest))
-    dest = get_fullkey_relative(PyString_AsString(py_dest),get_script_locale());
+    dest = PyString_AsString(py_dest); // get_fullkey_relative(PyString_AsString(py_dest),get_script_locale());
   else if(PyRoom_Check(py_dest)) {
     ROOM_DATA *to_room = PyRoom_AsRoom(py_dest);
     if(to_room != NULL)
@@ -542,8 +649,16 @@
     // if we're digging a special exit, add a cmd for it to the room cmd table
     if(get_cmd_move() && dir_num == DIR_NONE && dir_abbrev_num == DIR_NONE) {
       CMD_DATA *cmd = newPyCmd(cdir, get_cmd_move(), "player", TRUE);
-      cmdAddCheck(cmd, chk_can_move);
-      nearMapPut(roomGetCmdTable(room), cdir, NULL, cmd);
+
+      // add all of our movement checks
+      LIST_ITERATOR *chk_i = newListIterator(get_move_checks());
+      PyObject        *chk = NULL;
+      ITERATE_LIST(chk, chk_i) {
+	cmdAddPyCheck(cmd, chk);
+      } deleteListIterator(chk_i);
+
+      //cmdAddCheck(cmd, chk_can_move);
+      roomAddCmd(room, cdir, NULL, cmd);
     }
   }
 
@@ -637,8 +752,7 @@
   }
 
   // add the command to the game
-  nearMapPut(roomGetCmdTable(room), name, sort_by, 
-	     newPyCmd(name, func, group, TRUE));
+  roomAddCmd(room, name, sort_by, newPyCmd(name, func, group, TRUE));
   return Py_BuildValue("O", Py_None);
 }
 
@@ -666,7 +780,15 @@
   }
 
   // get the command
-  CMD_DATA *cmd = nearMapGet(roomGetCmdTable(room), name, FALSE);
+  CMD_DATA *cmd = roomGetCmd(room, name, FALSE);
+
+  // command doesn't exist; add a null command so we can 
+  // register just the check on larger-scale tables
+  if(cmd == NULL) {
+    cmd = newCmd(name, NULL, "", FALSE);
+    roomAddCmd(room, name, NULL, cmd);
+  }
+
   if(cmd != NULL)
     cmdAddPyCheck(cmd, func);
   return Py_BuildValue("O", Py_None);
@@ -842,6 +964,40 @@
   }
 }
 
+//
+// run all of a room's reset commands
+PyObject *PyRoom_reset(PyRoom *self, void *closure) {
+  ROOM_DATA *room = PyRoom_AsRoom((PyObject *)self);
+  if(room == NULL) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Tried to run resets for nonexistant room, %d",
+		 self->uid);
+    return NULL;
+  }
+  hookRun("reset_room", hookBuildInfo("rm", room));
+  return Py_BuildValue("");
+}
+
+PyObject *PyRoom_hasBit(PyObject *self, PyObject *args) {
+  char *bits = NULL;
+
+  // make sure we're getting passed the right type of data
+  if (!PyArg_ParseTuple(args, "s", &bits)) {
+    PyErr_Format(PyExc_TypeError, "hasBit only accepts strings.");
+    return NULL;
+  }
+
+  // pull out the object and check the type
+  ROOM_DATA *rm = PyRoom_AsRoom(self);
+  if(rm != NULL)
+    return Py_BuildValue("i", bitIsSet(roomGetBits(rm), bits));
+  else {
+    PyErr_Format(PyExc_StandardError, 
+		 "Tried to check bits of nonexistent room, %d.", PyRoom_AsUid(self));
+    return NULL;
+  }
+}
+
 
 
 //*****************************************************************************
@@ -892,6 +1048,12 @@
 PyMethodDef room_module_methods[] = {
   { "get_room", (PyCFunction)PyRoom_get_room, METH_VARARGS,
     "Takes a room key/locale and returns a pointer to that room." },
+  { "is_loaded", (PyCFunction)PyRoom_loaded, METH_VARARGS,
+    "Returns whether the given room key has been loaded to the game." },
+  { "instance",  (PyCFunction)PyRoom_instance, METH_VARARGS,
+    "Returns a new instanced room to the game." },
+  { "is_abstract",  (PyCFunction)PyRoom_is_abstract, METH_VARARGS,
+    "Returns whether a room with the specified prototype is abstract." },
   {NULL, NULL, 0, NULL}  /* Sentinel */
 };
 
@@ -940,6 +1102,12 @@
 			"the room's desc");
     PyRoom_addGetSetter("proto",   PyRoom_getclass,    NULL, 
 			"The room's class");
+    PyRoom_addGetSetter("locale",  PyRoom_getlocale,   NULL, 
+			"The zone we belong to");
+    PyRoom_addGetSetter("protoname",PyRoom_getprotoname,NULL, 
+			"The head of our proto");
+    PyRoom_addGetSetter("protos",  PyRoom_getprotos,   NULL, 
+			"The room's prototypes");
     PyRoom_addGetSetter("chars",   PyRoom_getchars,    NULL, 
 			"chars in the room");
     PyRoom_addGetSetter("objs",  PyRoom_getobjs,       NULL, 
@@ -980,6 +1148,8 @@
 		     "returns whether or not the room inherits from the proto");
     PyRoom_addMethod("getAuxiliary", PyRoom_get_auxiliary, METH_VARARGS,
 		     "get's the specified piece of aux data from the room");
+    PyRoom_addMethod("aux", PyRoom_get_auxiliary, METH_VARARGS,
+		     "get's the specified piece of aux data from the room");
     PyRoom_addMethod("getvar", PyRoom_getvar, METH_VARARGS,
 		    "get the value of a special variable the room has.");
     PyRoom_addMethod("setvar", PyRoom_setvar, METH_VARARGS,
@@ -990,6 +1160,10 @@
 		    "delete a variable from the room's variable table.");
     PyRoom_addMethod("delvar", PyRoom_deletevar, METH_VARARGS,
 		    "delete a variable from the room's variable table.");
+    PyRoom_addMethod("reset", PyRoom_reset, METH_NOARGS,
+		     "run all of the room's reset commands.");
+    PyRoom_addMethod("hasBit", PyRoom_hasBit, METH_VARARGS,
+		     "return whether or not the room has a specified bit.");
 
     // add in all the getsetters and methods
     makePyType(&PyRoom_Type, pyroom_getsetters, pyroom_methods);
diff -ruN ../nakedmudv3.7/src/scripts/pysocket.c src/scripts/pysocket.c
--- ../nakedmudv3.7/src/scripts/pysocket.c	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/pysocket.c	2009-03-02 01:00:40.000000000 -0500
@@ -20,6 +20,14 @@
 
 
 //*****************************************************************************
+// mandatory modules
+//*****************************************************************************
+#include "../editor/editor.h"
+#include "script_editor.h"
+
+
+
+//*****************************************************************************
 // local structures and defines
 //*****************************************************************************
 
@@ -117,6 +125,15 @@
   }
 }
 
+PyObject *PySocket_getcmdread(PySocket *self, void *closure) { 
+  SOCKET_DATA *sock = PySocket_AsSocket((PyObject *)self);
+  if(sock == NULL)
+    return NULL;
+  else {
+    return Py_BuildValue("i", socketHasCommand(sock));
+  }
+}
+
 PyObject *PySocket_get_outbound_text(PySocket *self, void *closure) {
   SOCKET_DATA *sock = PySocket_AsSocket((PyObject *)self);
   if(sock == NULL)
@@ -151,6 +168,32 @@
 			       TRUE : FALSE));
 }
 
+PyObject *PySocket_getstate(PySocket *self, void *closure) {
+  SOCKET_DATA *sock = PySocket_AsSocket((PyObject *)self);
+  if(sock == NULL)
+    return NULL;
+  else
+    return Py_BuildValue("s", socketGetState(sock));
+}
+
+PyObject *PySocket_getidletime(PySocket *self, void *closure) {
+  SOCKET_DATA *sock = PySocket_AsSocket((PyObject *)self);
+  if(sock == NULL)
+    return NULL;
+  else
+    return Py_BuildValue("f", socketGetIdleTime(sock));
+}
+
+PyObject *PySocket_gethostname(PySocket *self, void *closure) {
+  SOCKET_DATA *sock = PySocket_AsSocket((PyObject *)self);
+  if(sock == NULL)
+    return NULL;
+  else if(socketGetDNSLookupStatus(sock) == TSTATE_DONE)
+    return Py_BuildValue("s", socketGetHostname(sock));
+  else
+    return Py_BuildValue("s", "unresolved");
+}
+
 PyObject *PySocket_bust_prompt(PySocket *self, PyObject *closure) {
   SOCKET_DATA *sock = PySocket_AsSocket((PyObject *)self);
   if(sock == NULL) {
@@ -166,17 +209,18 @@
   SOCKET_DATA *sock = PySocket_AsSocket((PyObject *)self);
   PyObject *handler = NULL;
   PyObject  *prompt = NULL;
+  char       *state = NULL;
 
   if(sock == NULL)
     return NULL;
 
-  if (!PyArg_ParseTuple(args, "OO", &handler, &prompt)) {
+  if (!PyArg_ParseTuple(args, "OO|s", &handler, &prompt, &state)) {
     PyErr_Format(PyExc_TypeError, "handler and prompt function must "
 		 "be supplied.");
     return NULL;
   }
 
-  socketPushPyInputHandler(sock, handler, prompt);
+  socketPushPyInputHandler(sock, handler, prompt, (state ? state : ""));
   return Py_BuildValue("i", 1);
 }
 
@@ -238,6 +282,35 @@
   return Py_BuildValue("i", 1);
 }
 
+PyObject *PySocket_edit_text(PyObject *self, PyObject *args) {
+  PyObject *on_complete = NULL;
+  char            *text = NULL;
+  char            *type = NULL;
+  SOCKET_DATA     *sock = NULL;
+  EDITOR        *editor = text_editor;
+
+  if(!PyArg_ParseTuple(args, "sO|s", &text, &on_complete, &type)) {
+    PyErr_Format(PyExc_TypeError, "invalid arguments to sock.edit_text");
+    return NULL;
+  }
+
+  if(!PySocket_Check(self)) {
+    PyErr_Format(PyExc_TypeError, "Owner of edit_text not a socket");
+    return NULL;
+  }
+  else if( (sock = PySocket_AsSocket(self)) == NULL) {
+    PyErr_Format(PyExc_TypeError, "sock.edit_text called on non-existent socket.");
+    return NULL;
+  }
+
+  if(type != NULL && compares(type, "script"))
+    editor = script_editor;
+  
+  // begin the editor
+  socketStartPyEditorFunc(sock, editor, text, on_complete);
+  return Py_BuildValue("O", Py_None);
+}
+
 
 
 //*****************************************************************************
@@ -397,6 +470,8 @@
 			   "the socket's character.");
     PySocket_addGetSetter("ch",   PySocket_getchar, NULL,
 			   "the socket's character.");
+    PySocket_addGetSetter("has_input", PySocket_getcmdread, NULL,
+			  "Have we read any input this iteration?");
     PySocket_addGetSetter("outbound_text",
 			  PySocket_get_outbound_text,PySocket_set_outbound_text,
 			  "the socket's outbound text.");
@@ -404,10 +479,18 @@
 			  PySocket_get_can_use, NULL,
 			  "Returns whether or not the socket is ready for use. "
 			  "Sockets become available after their dns resolves.");
+    PySocket_addGetSetter("state", PySocket_getstate, NULL,
+			  "Returns the state that the socket is in.");
+    PySocket_addGetSetter("idle_time", PySocket_getidletime, NULL,
+			  "Returns how long (seconds) we've been idle.");
+    PySocket_addGetSetter("hostname", PySocket_gethostname, NULL,
+			  "return where we are connected from.");
 
     // add all of the basic methods
     PySocket_addMethod("getAuxiliary", PySocket_get_auxiliary, METH_VARARGS,
 		       "gets the socket auxiliary data with given key.");
+    PySocket_addMethod("aux", PySocket_get_auxiliary, METH_VARARGS,
+		       "gets the socket auxiliary data with given key.");
     PySocket_addMethod("send", PySocket_send, METH_VARARGS,
 		       "sends text to the socket with appended newline.");
     PySocket_addMethod("send_raw", PySocket_send_raw, METH_VARARGS,
@@ -422,6 +505,8 @@
 		       "closes the socket.");
     PySocket_addMethod("bust_prompt", PySocket_bust_prompt, METH_NOARGS,
 		       "busts the socket's prompt so it will be displayed.");
+    PySocket_addMethod("edit_text", PySocket_edit_text, METH_VARARGS, 
+		       "enter the text editor and begin editing something.");
 
     // add in all the getsetters and methods
     makePyType(&PySocket_Type, pysocket_getsetters, pysocket_methods);
diff -ruN ../nakedmudv3.7/src/scripts/pystorage.c src/scripts/pystorage.c
--- ../nakedmudv3.7/src/scripts/pystorage.c	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/pystorage.c	2009-03-02 01:00:40.000000000 -0500
@@ -72,8 +72,8 @@
 // return a python list of the sets in our storage list
 PyObject *PyStorageList_sets(PyObject *self, PyObject *args) {
   STORAGE_SET_LIST *set_list = ((PyStorageList *)self)->list;
-  STORAGE_SET           *set = NULL;
   PyObject             *list = PyList_New(0);
+  STORAGE_SET           *set = NULL;
 
   // add in all of the elements
   while( (set = storage_list_next(set_list)) != NULL) {
@@ -83,9 +83,7 @@
   }
 
   // return the new list
-  PyObject *retval = Py_BuildValue("O", list);
-  Py_DECREF(list);
-  return retval;
+  return list;
 }
 
 //
@@ -276,13 +274,8 @@
   char *key = PyStorageSet_readParseKey(args);
   if(key == NULL)
     return NULL;
-  else {
-    PyObject *pylist =
-      newPyStorageList(read_list(((PyStorageSet*)self)->set, key));
-    PyObject *retval = Py_BuildValue("O", pylist);
-    Py_DECREF(pylist);
-    return retval;
-  }
+  else
+      return newPyStorageList(read_list(((PyStorageSet*)self)->set, key));
 }
 
 //
@@ -291,13 +284,8 @@
   char *key = PyStorageSet_readParseKey(args);
   if(key == NULL)
     return NULL;
-  else {
-    PyObject *pyset = 
-      newPyStorageSet(read_set(((PyStorageSet *)self)->set, key));
-    PyObject *retval = Py_BuildValue("O", pyset);
-    Py_DECREF(pyset);
-    return retval;
-  }
+  else
+    return newPyStorageSet(read_set(((PyStorageSet *)self)->set, key));
 }
 
 
@@ -442,6 +430,8 @@
     "being used. Garbage collection will not delete the set." },
   { "contains",    PyStorageSet_contains,    METH_VARARGS,
     "Returns True if the set contains the given key, and false otherwise." },
+  { "__contains__",    PyStorageSet_contains,    METH_VARARGS,
+    "Returns True if the set contains the given key, and false otherwise." },
 
   {NULL, NULL, 0, NULL}  /* Sentinel */
 };
diff -ruN ../nakedmudv3.7/src/scripts/pystorage.h src/scripts/pystorage.h
--- ../nakedmudv3.7/src/scripts/pystorage.h	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/pystorage.h	2009-03-02 01:00:40.000000000 -0500
@@ -21,4 +21,8 @@
 // return the storage set that is contained within it.
 STORAGE_SET *PyStorageSet_AsSet(PyObject *set);
 
+//
+// checks to see of the object is a PyStorageSet
+int PyStorageSet_Check(PyObject *value);
+
 #endif // PYSTORAGE_H
diff -ruN ../nakedmudv3.7/src/scripts/script_editor.c src/scripts/script_editor.c
--- ../nakedmudv3.7/src/scripts/script_editor.c	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/script_editor.c	2009-03-02 01:00:40.000000000 -0500
@@ -149,6 +149,21 @@
   }
 }
 
+//
+// same deal as scriptEditorInsert
+void scriptEditorEditLine(SOCKET_DATA *sock, char *arg, BUFFER *buf) { 
+  char tmp[SMALL_BUFFER];
+  arg = one_arg(arg, tmp);
+  int line = atoi(tmp);
+  if(!isdigit(*tmp) || !bufferReplaceLine(buf, arg, line))
+    text_to_buffer(sock, "Line does not exist.\r\n");
+  else {
+    text_to_buffer(sock, "Line replaced.\r\n");
+    bufferReplace(buf, "\r", "", TRUE);
+  }
+}
+
+
 
 //*****************************************************************************
 // implementation of script_editor.h
@@ -169,6 +184,8 @@
 		   scriptEditorFormat);
   editorAddCommand(script_editor, "i", "# <txt> Insert new text at the specified line number",
 		   scriptEditorInsert);
+  editorAddCommand(script_editor, "e", "# <txt> Sets the text at the specified line to the new text", 
+		   scriptEditorEditLine);
 
   auxiliariesInstall("script_editor_aux_data", 
 		     newAuxiliaryFuncs(AUXILIARY_TYPE_SOCKET,
diff -ruN ../nakedmudv3.7/src/scripts/scripts.c src/scripts/scripts.c
--- ../nakedmudv3.7/src/scripts/scripts.c	2008-12-06 00:20:20.000000000 -0500
+++ src/scripts/scripts.c	2009-03-02 01:00:40.000000000 -0500
@@ -647,7 +647,8 @@
       bufferClear(code);
       for(j = 0; j < end; j++)
 	bprintf(code, "%c", *(bufferString(desc) + i + j));
-      bufferReplace(code, "\n", "", TRUE);
+      bufferReplace(code, "\n", " ", TRUE);
+      bufferReplace(code, "\r", "", TRUE);
 
       // skip i up to the end
       i = i + end;
@@ -731,6 +732,13 @@
   return listHead(locale_stack);
 }
 
+const char *get_smart_locale(CHAR_DATA *ch) {
+  const char *locale = get_script_locale();
+  if(locale == NULL && charGetRoom(ch) != NULL)
+    locale = get_key_locale(roomGetClass(charGetRoom(ch)));
+  return locale;
+}
+
 bool last_script_ok(void) {
   return script_ok;
 }
@@ -863,6 +871,8 @@
   "and",
   "or",
   "not",
+  "break",
+  "continue",
   NULL
 };
 
@@ -908,7 +918,7 @@
   for(i = 0; ptr[i] != '\0'; i++) {
     // take off the color for digits
     if(in_digit && !isdigit(ptr[i])) {
-      sprintf(line+line_i, "{g");
+      sprintf(line+line_i, "{n");
       line_i += 2;
       in_digit = FALSE;
     } // NO ELSE ... we might need to color something else
@@ -937,7 +947,7 @@
 	    !(in_string && string_type != ptr[i])) {
 
       if(in_string && ptr[i] == string_type)
-	sprintf(line+line_i, "\%c{g", string_type);
+	sprintf(line+line_i, "\%c{n", string_type);
       else
 	sprintf(line+line_i, "{w%c", ptr[i]);
       
@@ -957,7 +967,7 @@
 	  *line_num_info = '\0';
 
 	line[line_i] = '\0';
-	send_to_socket(sock, "%s{g%s{n\r\n", line_num_info, line);
+	send_to_socket(sock, "%s{n%s{n\r\n", line_num_info, line);
 	*line = '\0';
 	line_i = 0;
 	line_num++;
@@ -969,7 +979,7 @@
     else if(!(in_line_comment || in_digit || in_string) &&
 	    (syn_to_color = check_for_control(ptr, i)) != -1) {
       sprintf(line+line_i-strlen(control_table[syn_to_color])+1,
-	      "{p%s{g", control_table[syn_to_color]);
+	      "{p%s{n", control_table[syn_to_color]);
       line_i += 5; // the two markers for the color, and one for new character
     }
 
@@ -983,7 +993,7 @@
   // send the last line
   if(*line) {
     if(show_line_nums)
-      send_to_socket(sock, "{c%2d]{g  %s{n\r\n", line_num, line);
+      send_to_socket(sock, "{c%2d]{n  %s{n\r\n", line_num, line);
     else
       send_to_socket(sock, "%s{n\r\n", line);
   }
diff -ruN ../nakedmudv3.7/src/scripts/scripts.h src/scripts/scripts.h
--- ../nakedmudv3.7/src/scripts/scripts.h	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/scripts.h	2009-03-02 01:00:40.000000000 -0500
@@ -187,6 +187,11 @@
 const char *get_script_locale(void);
 
 //
+// returns a smart locale for a script. If there is a locale on the script
+// stack, return that. Otherwise, return the locale for the character's room
+const char *get_smart_locale(CHAR_DATA *ch);
+
+//
 // returns true if the last script ran without any errors
 bool last_script_ok(void);
 
diff -ruN ../nakedmudv3.7/src/scripts/trigedit.c src/scripts/trigedit.c
--- ../nakedmudv3.7/src/scripts/trigedit.c	2008-12-06 00:20:20.000000000 -0500
+++ src/scripts/trigedit.c	2009-03-02 01:08:06.000000000 -0500
@@ -95,7 +95,8 @@
   { "greet",          "mob"       },
   { "enter",          "mob, room" },
   { "exit",           "mob, room" },
-  { "move",           "mob"       },
+  { "self_enter",     "mob"       },
+  { "self_exit",      "mob"       },
   { "drop",           "obj, room" },
   { "get",            "obj, room" },
   { "give",           "obj, mob"  },
@@ -103,8 +104,10 @@
   { "wear",           "obj, mob"  },
   { "remove",         "obj, mob"  },
   { "reset",          "room"      },
-  { "combat",         "mob"       },
+  { "look",           "obj, mob, room" },
   { "open",           "obj, room" },
+  { "close",          "obj, room" },
+  { "to_game",        "obj, mob, room" },
   { "", "" },
 };
 
@@ -198,6 +201,8 @@
   // we need a key
   if(!arg || !*arg)
     send_to_char(ch,"Please supply the key of a trigger you wish to edit.\r\n");
+  else if(key_malformed(arg))
+    send_to_char(ch, "You entered a malformed trigger key.\r\n");
   else {
     char name[SMALL_BUFFER], locale[SMALL_BUFFER];
     if(!parse_worldkey_relative(ch, arg, name, locale))
diff -ruN ../nakedmudv3.7/src/scripts/triggers.c src/scripts/triggers.c
--- ../nakedmudv3.7/src/scripts/triggers.c	2008-12-06 00:20:20.000000000 -0500
+++ src/scripts/triggers.c	2009-03-02 01:00:40.000000000 -0500
@@ -48,6 +48,7 @@
   if(trigger->key)  free(trigger->key);
   deleteBuffer(trigger->code);
   Py_XDECREF(trigger->pycode);
+  free(trigger);
 }
 
 STORAGE_SET *triggerStore(TRIGGER_DATA *trigger) {
@@ -124,13 +125,12 @@
 void triggerRun(TRIGGER_DATA *trigger, PyObject *dict) {
   // if we haven't yet run the trigger, compile the source code
   if(trigger->pycode == NULL)
-    trigger->pycode = 
-      run_script_forcode(dict, bufferString(trigger->code),
-			 get_key_locale(triggerGetKey(trigger)));
+    trigger->pycode = run_script_forcode(dict, bufferString(trigger->code),
+					 get_key_locale(triggerGetKey(trigger)));
   // run right from the code
   else {
     run_code(trigger->pycode, dict, get_key_locale(triggerGetKey(trigger)));
-    
+
     if(!last_script_ok())
       log_pyerr("Trigger %s terminated with an error:\r\n%s",
 		trigger->key, bufferString(trigger->code));
